structure NatMinPlus : SEMIRING =
    struct
        type t = int
        val zero = case Int.maxInt of 
                       SOME n => n 
                     | NONE   => raise Domain
        fun sum (x,y) = Int.min(x,y)
        val unit = 0
        fun prod (x,y) = (x + y) handle Overflow => zero
    end
structure LG = LatticeGraph(val dim = 4; structure Ring = NatMinPlus)

val H = LG.Mat.tabulate (fn (i,j) => if j = i+1 then 1 else LG.Mat.Ring.zero)
val V = LG.Mat.tabulate (fn (i,j) => if j = i+1 then 1 else LG.Mat.Ring.zero)
val q = (1,1)

val sp = LG.shortestPaths (H,V,q)

val sp =
  #[#[1073741823,1073741823,1073741823,1073741823],
    #[1073741823,1073741823,1,2],
    #[1073741823,1,2,3],
    #[1073741823,2,3,4]]  : LG.Mat.t
