(* Compiler.Control.Print.printDepth := 30; *)

structure BoolRing : SEMIRING =
    struct
        type t = bool
        val zero = false
        fun sum (x,y) = x orelse y
        val unit = true
        fun prod (x,y) = x andalso y
    end

structure IntRing : SEMIRING =
    struct
        type t = int
        val zero = 0
        fun sum (x,y) = x + y
        val unit = 1
        fun prod (x,y) = x * y
    end

structure Boole = ScaleDisc (val max = 1)

