structure Boole = ScaleDisc(val max = 1);
structure BM = Matrices(Boole);

fun wegew A j = 
    let 
        val (n,m) = BM.dimension A 
        val sumR  = BM.Ring.sum
        val prodR = BM.Ring.prod
    in 
        if not(n=m) then raise Size 
        else
            if j = 0 then A 
            else 
                let 
                    val C = wegew A (j-1) 
                in 
                    BM.tabulate (n,n) 
                    (fn (i,k) => sumR(BM.sub(C,(i,k)),
                                      prodR(BM.sub(C,(i,j-1)),
                                            BM.sub(C,(j-1,k)))))
                end
    end

fun tcw A =
    let 
        val (n,m) = BM.dimension A
    in
        if not(n=m) then raise Size else wegew A n
    end
              
